"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var storybook_1 = require("@devexperts/tools/dist/utils/storybook");
var add_icon_1 = require("../../icons/add-icon");
var calendar_icon_1 = require("../../icons/calendar-icon");
var decrease_icon_1 = require("../../icons/decrease-icon");
var small_cross_icon_1 = require("../../icons/small-cross-icon");
var DateInput_1 = require("./DateInput");
var Control_1 = require("../Control/Control");
var Demo_1 = require("../demo/Demo");
var Button_1 = require("../Button/Button");
var Stateful = Control_1.stateful()(DateInput_1.DateInput);
var onChange = function (value) { return storybook_1.action('change')(value); };
var onClear = function () { return storybook_1.action('clear')(); };
var Calendar = function (props) {
    var onChange = function () { return props.onValueChange && props.onValueChange(new Date()); };
    return (React.createElement("div", { onMouseDown: props.onMouseDown },
        "calendar",
        React.createElement(Button_1.Button, { onClick: onChange }, "click me")));
};
var DateInputPage = /** @class */ (function (_super) {
    tslib_1.__extends(DateInputPage, _super);
    function DateInputPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {};
        _this.onControlledManualClear = function () {
            _this.setState({
                value: null,
            });
        };
        _this.onControlledClear = function () {
            _this.setState({
                value: undefined,
            });
        };
        _this.onControlledChange = function (value) {
            console.log(value);
            _this.setState({
                value: value,
            });
        };
        return _this;
    }
    DateInputPage.prototype.render = function () {
        var _this = this;
        var _a = this.props, isDisabled = _a.isDisabled, error = _a.error;
        return (React.createElement(Demo_1.Demo, null,
            React.createElement("input", { type: "date", id: "date", disabled: isDisabled }),
            React.createElement("section", null,
                React.createElement("h1", null, "Controlled"),
                React.createElement(DateInput_1.DateInput, { onValueChange: this.onControlledChange, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), onClear: this.onControlledClear, error: error, value: this.state.value }),
                React.createElement(Button_1.Button, { onClick: this.onControlledManualClear }, "Clear")),
            React.createElement("section", null,
                React.createElement("h1", null, "without Calendar"),
                React.createElement(Stateful, { decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), isDisabled: isDisabled, incrementIcon: React.createElement(add_icon_1.AddIcon, null), clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), error: error, onValueChange: onChange, onClear: onClear, defaultValue: new Date() }),
                React.createElement(Stateful, { decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), isDisabled: isDisabled, incrementIcon: React.createElement(add_icon_1.AddIcon, null), clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), onValueChange: onChange, error: error, onClear: onClear, defaultValue: new Date() }),
                React.createElement(Stateful, { decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), isDisabled: isDisabled, incrementIcon: React.createElement(add_icon_1.AddIcon, null), clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), onValueChange: onChange, error: error, onClear: onClear, defaultValue: new Date() })),
            React.createElement("section", null,
                React.createElement("h1", null, "with calendar"),
                React.createElement(Stateful, { decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), isDisabled: isDisabled, error: error, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), calendarIcon: React.createElement(calendar_icon_1.CalendarIcon, null), onValueChange: onChange, onClear: onClear, Calendar: Calendar, defaultValue: new Date() }),
                React.createElement(Stateful, { decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), isDisabled: isDisabled, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), error: error, calendarIcon: React.createElement(calendar_icon_1.CalendarIcon, null), onValueChange: onChange, onClear: onClear, Calendar: Calendar, target: this.target, defaultValue: new Date() })),
            React.createElement("section", null,
                React.createElement("h1", null, "calendar output target"),
                React.createElement("div", { ref: function (el) { return (_this.target = el); } }))));
    };
    return DateInputPage;
}(React.Component));
storybook_1.storiesOf('DateInput', module)
    .add('default', function () { return React.createElement(DateInputPage, null); })
    .add('disabled', function () { return React.createElement(DateInputPage, { isDisabled: true }); })
    .add('invalid', function () { return React.createElement(DateInputPage, { error: true }); });
//# sourceMappingURL=DateInput.page.js.map